"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.changePool = changePool;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function changePool(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.adminAuthority, isSigner: true, isWritable: true },
        { pubkey: accounts.strategy, isSigner: false, isWritable: true },
        { pubkey: accounts.oldPosition, isSigner: false, isWritable: false },
        { pubkey: accounts.baseVaultAuthority, isSigner: false, isWritable: false },
        { pubkey: accounts.newPool, isSigner: false, isWritable: false },
        {
            pubkey: accounts.strategyRewardVault0OrBaseVaultAuthority,
            isSigner: false,
            isWritable: false,
        },
        {
            pubkey: accounts.strategyRewardVault1OrBaseVaultAuthority,
            isSigner: false,
            isWritable: false,
        },
        {
            pubkey: accounts.strategyRewardVault2OrBaseVaultAuthority,
            isSigner: false,
            isWritable: false,
        },
    ];
    const identifier = Buffer.from([141, 221, 123, 235, 35, 9, 145, 201]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=changePool.js.map