import { TransactionInstruction, PublicKey } from "@solana/web3.js";
export interface CloseStrategyAccounts {
    adminAuthority: PublicKey;
    strategy: PublicKey;
    oldPositionOrBaseVaultAuthority: PublicKey;
    oldPositionMintOrBaseVaultAuthority: PublicKey;
    oldPositionTokenAccountOrBaseVaultAuthority: PublicKey;
    oldTickArrayLowerOrBaseVaultAuthority: PublicKey;
    oldTickArrayUpperOrBaseVaultAuthority: PublicKey;
    pool: PublicKey;
    tokenAVault: PublicKey;
    tokenBVault: PublicKey;
    userTokenAAta: PublicKey;
    userTokenBAta: PublicKey;
    tokenAMint: PublicKey;
    tokenBMint: PublicKey;
    /** If rewards are uninitialized, pass this as strategy. */
    reward0Vault: PublicKey;
    /** If rewards are uninitialized, pass this as strategy. */
    reward1Vault: PublicKey;
    /** If rewards are uninitialized, pass this as strategy. */
    reward2Vault: PublicKey;
    /** If rewards are uninitialized, pass this as strategy. */
    kaminoReward0Vault: PublicKey;
    /** If rewards are uninitialized, pass this as strategy. */
    kaminoReward1Vault: PublicKey;
    /** If rewards are uninitialized, pass this as strategy. */
    kaminoReward2Vault: PublicKey;
    /** If rewards are uninitialized, pass this as strategy. */
    userReward0Ata: PublicKey;
    /** If rewards are uninitialized, pass this as strategy. */
    userReward1Ata: PublicKey;
    /** If rewards are uninitialized, pass this as strategy. */
    userReward2Ata: PublicKey;
    /** If rewards are uninitialized, pass this as strategy. */
    userKaminoReward0Ata: PublicKey;
    /** If rewards are uninitialized, pass this as strategy. */
    userKaminoReward1Ata: PublicKey;
    /** If rewards are uninitialized, pass this as strategy. */
    userKaminoReward2Ata: PublicKey;
    baseVaultAuthority: PublicKey;
    poolProgram: PublicKey;
    tokenProgram: PublicKey;
    tokenATokenProgram: PublicKey;
    tokenBTokenProgram: PublicKey;
    system: PublicKey;
    eventAuthority: PublicKey;
}
export declare function closeStrategy(accounts: CloseStrategyAccounts, programId?: PublicKey): TransactionInstruction;
//# sourceMappingURL=closeStrategy.d.ts.map