"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.closeStrategy = closeStrategy;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function closeStrategy(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.adminAuthority, isSigner: true, isWritable: true },
        { pubkey: accounts.strategy, isSigner: false, isWritable: true },
        {
            pubkey: accounts.oldPositionOrBaseVaultAuthority,
            isSigner: false,
            isWritable: true,
        },
        {
            pubkey: accounts.oldPositionMintOrBaseVaultAuthority,
            isSigner: false,
            isWritable: true,
        },
        {
            pubkey: accounts.oldPositionTokenAccountOrBaseVaultAuthority,
            isSigner: false,
            isWritable: true,
        },
        {
            pubkey: accounts.oldTickArrayLowerOrBaseVaultAuthority,
            isSigner: false,
            isWritable: true,
        },
        {
            pubkey: accounts.oldTickArrayUpperOrBaseVaultAuthority,
            isSigner: false,
            isWritable: true,
        },
        { pubkey: accounts.pool, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenAVault, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenBVault, isSigner: false, isWritable: true },
        { pubkey: accounts.userTokenAAta, isSigner: false, isWritable: true },
        { pubkey: accounts.userTokenBAta, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenAMint, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenBMint, isSigner: false, isWritable: true },
        { pubkey: accounts.reward0Vault, isSigner: false, isWritable: true },
        { pubkey: accounts.reward1Vault, isSigner: false, isWritable: true },
        { pubkey: accounts.reward2Vault, isSigner: false, isWritable: true },
        { pubkey: accounts.kaminoReward0Vault, isSigner: false, isWritable: true },
        { pubkey: accounts.kaminoReward1Vault, isSigner: false, isWritable: true },
        { pubkey: accounts.kaminoReward2Vault, isSigner: false, isWritable: true },
        { pubkey: accounts.userReward0Ata, isSigner: false, isWritable: true },
        { pubkey: accounts.userReward1Ata, isSigner: false, isWritable: true },
        { pubkey: accounts.userReward2Ata, isSigner: false, isWritable: true },
        {
            pubkey: accounts.userKaminoReward0Ata,
            isSigner: false,
            isWritable: true,
        },
        {
            pubkey: accounts.userKaminoReward1Ata,
            isSigner: false,
            isWritable: true,
        },
        {
            pubkey: accounts.userKaminoReward2Ata,
            isSigner: false,
            isWritable: true,
        },
        { pubkey: accounts.baseVaultAuthority, isSigner: false, isWritable: true },
        { pubkey: accounts.poolProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenATokenProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenBTokenProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.system, isSigner: false, isWritable: false },
        { pubkey: accounts.eventAuthority, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([56, 247, 170, 246, 89, 221, 134, 200]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=closeStrategy.js.map