"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.collectFeesAndRewards = collectFeesAndRewards;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function collectFeesAndRewards(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.user, isSigner: true, isWritable: true },
        { pubkey: accounts.strategy, isSigner: false, isWritable: true },
        { pubkey: accounts.globalConfig, isSigner: false, isWritable: false },
        { pubkey: accounts.baseVaultAuthority, isSigner: false, isWritable: true },
        { pubkey: accounts.pool, isSigner: false, isWritable: true },
        { pubkey: accounts.tickArrayLower, isSigner: false, isWritable: true },
        { pubkey: accounts.tickArrayUpper, isSigner: false, isWritable: true },
        { pubkey: accounts.position, isSigner: false, isWritable: true },
        {
            pubkey: accounts.raydiumProtocolPositionOrBaseVaultAuthority,
            isSigner: false,
            isWritable: true,
        },
        {
            pubkey: accounts.positionTokenAccount,
            isSigner: false,
            isWritable: false,
        },
        { pubkey: accounts.tokenAVault, isSigner: false, isWritable: true },
        { pubkey: accounts.poolTokenVaultA, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenBVault, isSigner: false, isWritable: true },
        { pubkey: accounts.poolTokenVaultB, isSigner: false, isWritable: true },
        {
            pubkey: accounts.treasuryFeeTokenAVault,
            isSigner: false,
            isWritable: true,
        },
        {
            pubkey: accounts.treasuryFeeTokenBVault,
            isSigner: false,
            isWritable: true,
        },
        {
            pubkey: accounts.treasuryFeeVaultAuthority,
            isSigner: false,
            isWritable: false,
        },
        { pubkey: accounts.reward0Vault, isSigner: false, isWritable: true },
        { pubkey: accounts.reward1Vault, isSigner: false, isWritable: true },
        { pubkey: accounts.reward2Vault, isSigner: false, isWritable: true },
        { pubkey: accounts.poolRewardVault0, isSigner: false, isWritable: true },
        { pubkey: accounts.poolRewardVault1, isSigner: false, isWritable: true },
        { pubkey: accounts.poolRewardVault2, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenAMint, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenBMint, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenATokenProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenBTokenProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.memoProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenProgram2022, isSigner: false, isWritable: false },
        { pubkey: accounts.poolProgram, isSigner: false, isWritable: false },
        {
            pubkey: accounts.instructionSysvarAccount,
            isSigner: false,
            isWritable: false,
        },
        { pubkey: accounts.eventAuthority, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([113, 18, 75, 8, 182, 31, 105, 186]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=collectFeesAndRewards.js.map