import { TransactionInstruction, PublicKey } from "@solana/web3.js";
import BN from "bn.js";
export interface EmergencySwapArgs {
    aToB: boolean;
    targetLimitBps: BN;
}
export interface EmergencySwapAccounts {
    adminAuthority: PublicKey;
    strategy: PublicKey;
    globalConfig: PublicKey;
    tokenAMint: PublicKey;
    tokenBMint: PublicKey;
    tokenAVault: PublicKey;
    tokenBVault: PublicKey;
    baseVaultAuthority: PublicKey;
    pool: PublicKey;
    position: PublicKey;
    poolTokenVaultA: PublicKey;
    poolTokenVaultB: PublicKey;
    /** Payer must send this correctly. */
    tickArray0: PublicKey;
    /** Payer must send this correctly. */
    tickArray1: PublicKey;
    /** Payer must send this correctly. */
    tickArray2: PublicKey;
    oracle: PublicKey;
    poolProgram: PublicKey;
    scopePrices: PublicKey;
    tokenInfos: PublicKey;
    tokenATokenProgram: PublicKey;
    tokenBTokenProgram: PublicKey;
    memoProgram: PublicKey;
}
export declare const layout: any;
export declare function emergencySwap(args: EmergencySwapArgs, accounts: EmergencySwapAccounts, programId?: PublicKey): TransactionInstruction;
//# sourceMappingURL=emergencySwap.d.ts.map