"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeCollateralInfo = initializeCollateralInfo;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function initializeCollateralInfo(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.adminAuthority, isSigner: true, isWritable: true },
        { pubkey: accounts.globalConfig, isSigner: false, isWritable: true },
        { pubkey: accounts.collInfo, isSigner: false, isWritable: true },
        { pubkey: accounts.systemProgram, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([74, 61, 216, 76, 244, 91, 18, 119]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=initializeCollateralInfo.js.map