"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeGlobalConfig = initializeGlobalConfig;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function initializeGlobalConfig(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.adminAuthority, isSigner: true, isWritable: true },
        { pubkey: accounts.globalConfig, isSigner: false, isWritable: true },
        { pubkey: accounts.systemProgram, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([113, 216, 122, 131, 225, 209, 22, 55]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=initializeGlobalConfig.js.map