import { TransactionInstruction, PublicKey } from "@solana/web3.js";
import BN from "bn.js";
export interface InitializeStrategyArgs {
    strategyType: BN;
    tokenACollateralId: BN;
    tokenBCollateralId: BN;
}
export interface InitializeStrategyAccounts {
    adminAuthority: PublicKey;
    globalConfig: PublicKey;
    /** Program owner also checked. */
    pool: PublicKey;
    tokenAMint: PublicKey;
    tokenBMint: PublicKey;
    tokenAVault: PublicKey;
    tokenBVault: PublicKey;
    baseVaultAuthority: PublicKey;
    sharesMint: PublicKey;
    sharesMintAuthority: PublicKey;
    tokenInfos: PublicKey;
    systemProgram: PublicKey;
    rent: PublicKey;
    tokenProgram: PublicKey;
    tokenATokenProgram: PublicKey;
    tokenBTokenProgram: PublicKey;
    strategy: PublicKey;
}
export declare const layout: any;
export declare function initializeStrategy(args: InitializeStrategyArgs, accounts: InitializeStrategyAccounts, programId?: PublicKey): TransactionInstruction;
//# sourceMappingURL=initializeStrategy.d.ts.map