import { TransactionInstruction, PublicKey } from "@solana/web3.js";
import BN from "bn.js";
export interface OpenLiquidityPositionArgs {
    tickLowerIndex: BN;
    tickUpperIndex: BN;
    bump: number;
}
export interface OpenLiquidityPositionAccounts {
    adminAuthority: PublicKey;
    strategy: PublicKey;
    globalConfig: PublicKey;
    pool: PublicKey;
    tickArrayLower: PublicKey;
    tickArrayUpper: PublicKey;
    baseVaultAuthority: PublicKey;
    position: PublicKey;
    positionMint: PublicKey;
    positionMetadataAccount: PublicKey;
    positionTokenAccount: PublicKey;
    rent: PublicKey;
    system: PublicKey;
    tokenProgram: PublicKey;
    tokenProgram2022: PublicKey;
    tokenATokenProgram: PublicKey;
    tokenBTokenProgram: PublicKey;
    memoProgram: PublicKey;
    associatedTokenProgram: PublicKey;
    poolProgram: PublicKey;
    oldTickArrayLowerOrBaseVaultAuthority: PublicKey;
    oldTickArrayUpperOrBaseVaultAuthority: PublicKey;
    oldPositionOrBaseVaultAuthority: PublicKey;
    oldPositionMintOrBaseVaultAuthority: PublicKey;
    oldPositionTokenAccountOrBaseVaultAuthority: PublicKey;
    tokenAVault: PublicKey;
    tokenBVault: PublicKey;
    tokenAMint: PublicKey;
    tokenBMint: PublicKey;
    poolTokenVaultA: PublicKey;
    poolTokenVaultB: PublicKey;
    scopePrices: PublicKey;
    tokenInfos: PublicKey;
    eventAuthority: PublicKey;
    consensusAccount: PublicKey;
}
export declare const layout: any;
export declare function openLiquidityPosition(args: OpenLiquidityPositionArgs, accounts: OpenLiquidityPositionAccounts, programId?: PublicKey): TransactionInstruction;
//# sourceMappingURL=openLiquidityPosition.d.ts.map