"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.layout = void 0;
exports.orcaSwap = orcaSwap;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const borsh = __importStar(require("@coral-xyz/borsh")); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
exports.layout = borsh.struct([
    borsh.u64("amount"),
    borsh.u64("otherAmountThreshold"),
    borsh.u128("sqrtPriceLimit"),
    borsh.bool("amountSpecifiedIsInput"),
    borsh.bool("aToB"),
]);
function orcaSwap(args, accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.funder, isSigner: true, isWritable: true },
        { pubkey: accounts.tokenATokenProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenBTokenProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.memoProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenAuthority, isSigner: false, isWritable: false },
        { pubkey: accounts.whirlpool, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenOwnerAccountA, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenVaultA, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenOwnerAccountB, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenVaultB, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenMintA, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenMintB, isSigner: false, isWritable: false },
        { pubkey: accounts.tickArray0, isSigner: false, isWritable: false },
        { pubkey: accounts.tickArray1, isSigner: false, isWritable: false },
        { pubkey: accounts.tickArray2, isSigner: false, isWritable: false },
        { pubkey: accounts.oracle, isSigner: false, isWritable: false },
        { pubkey: accounts.whirlpoolProgram, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([33, 94, 249, 97, 250, 254, 198, 93]);
    const buffer = Buffer.alloc(1000);
    const len = exports.layout.encode({
        amount: args.amount,
        otherAmountThreshold: args.otherAmountThreshold,
        sqrtPriceLimit: args.sqrtPriceLimit,
        amountSpecifiedIsInput: args.amountSpecifiedIsInput,
        aToB: args.aToB,
    }, buffer);
    const data = Buffer.concat([identifier, buffer]).slice(0, 8 + len);
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=orcaSwap.js.map