"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.permisionlessWithdrawFromTreasury = permisionlessWithdrawFromTreasury;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function permisionlessWithdrawFromTreasury(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.signer, isSigner: true, isWritable: true },
        { pubkey: accounts.globalConfig, isSigner: false, isWritable: false },
        { pubkey: accounts.mint, isSigner: false, isWritable: false },
        { pubkey: accounts.treasuryFeeVault, isSigner: false, isWritable: true },
        {
            pubkey: accounts.treasuryFeeVaultAuthority,
            isSigner: false,
            isWritable: true,
        },
        { pubkey: accounts.tokenAccount, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenProgram, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([167, 36, 32, 79, 97, 170, 183, 108]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=permisionlessWithdrawFromTreasury.js.map