import { TransactionInstruction, PublicKey } from "@solana/web3.js";
import BN from "bn.js";
export interface SingleTokenDepositWithMinArgs {
    tokenAMinPostDepositBalance: BN;
    tokenBMinPostDepositBalance: BN;
}
export interface SingleTokenDepositWithMinAccounts {
    user: PublicKey;
    strategy: PublicKey;
    globalConfig: PublicKey;
    pool: PublicKey;
    position: PublicKey;
    tickArrayLower: PublicKey;
    tickArrayUpper: PublicKey;
    tokenAVault: PublicKey;
    tokenBVault: PublicKey;
    baseVaultAuthority: PublicKey;
    tokenAAta: PublicKey;
    tokenBAta: PublicKey;
    tokenAMint: PublicKey;
    tokenBMint: PublicKey;
    userSharesAta: PublicKey;
    sharesMint: PublicKey;
    sharesMintAuthority: PublicKey;
    scopePrices: PublicKey;
    tokenInfos: PublicKey;
    tokenProgram: PublicKey;
    tokenATokenProgram: PublicKey;
    tokenBTokenProgram: PublicKey;
    instructionSysvarAccount: PublicKey;
}
export declare const layout: any;
export declare function singleTokenDepositWithMin(args: SingleTokenDepositWithMinArgs, accounts: SingleTokenDepositWithMinAccounts, programId?: PublicKey): TransactionInstruction;
//# sourceMappingURL=singleTokenDepositWithMin.d.ts.map