import { TransactionInstruction, PublicKey } from "@solana/web3.js";
import BN from "bn.js";
export interface SwapRewardsArgs {
    tokenAIn: BN;
    tokenBIn: BN;
    rewardIndex: BN;
    rewardCollateralId: BN;
    minCollateralTokenOut: BN;
}
export interface SwapRewardsAccounts {
    user: PublicKey;
    strategy: PublicKey;
    globalConfig: PublicKey;
    pool: PublicKey;
    tokenAVault: PublicKey;
    tokenBVault: PublicKey;
    rewardVault: PublicKey;
    baseVaultAuthority: PublicKey;
    treasuryFeeTokenAVault: PublicKey;
    treasuryFeeTokenBVault: PublicKey;
    treasuryFeeVaultAuthority: PublicKey;
    tokenAMint: PublicKey;
    tokenBMint: PublicKey;
    rewardMint: PublicKey;
    userTokenAAta: PublicKey;
    userTokenBAta: PublicKey;
    userRewardTokenAccount: PublicKey;
    scopePrices: PublicKey;
    tokenInfos: PublicKey;
    systemProgram: PublicKey;
    tokenATokenProgram: PublicKey;
    tokenBTokenProgram: PublicKey;
    rewardTokenProgram: PublicKey;
    instructionSysvarAccount: PublicKey;
}
export declare const layout: any;
export declare function swapRewards(args: SwapRewardsArgs, accounts: SwapRewardsAccounts, programId?: PublicKey): TransactionInstruction;
//# sourceMappingURL=swapRewards.d.ts.map