import { TransactionInstruction, PublicKey } from "@solana/web3.js";
import BN from "bn.js";
export interface SwapUnevenVaultsArgs {
    targetLimitBps: BN;
}
export interface SwapUnevenVaultsAccounts {
    actionsAuthority: PublicKey;
    strategy: PublicKey;
    globalConfig: PublicKey;
    tokenAVault: PublicKey;
    tokenBVault: PublicKey;
    tokenAMint: PublicKey;
    tokenBMint: PublicKey;
    baseVaultAuthority: PublicKey;
    pool: PublicKey;
    position: PublicKey;
    raydiumPoolConfigOrBaseVaultAuthority: PublicKey;
    poolTokenVaultA: PublicKey;
    poolTokenVaultB: PublicKey;
    /** Payer must send this correctly. */
    tickArray0: PublicKey;
    /** Payer must send this correctly. */
    tickArray1: PublicKey;
    /** Payer must send this correctly. */
    tickArray2: PublicKey;
    oracle: PublicKey;
    poolProgram: PublicKey;
    scopePrices: PublicKey;
    tokenInfos: PublicKey;
    tickArrayLower: PublicKey;
    tickArrayUpper: PublicKey;
    tokenATokenProgram: PublicKey;
    tokenBTokenProgram: PublicKey;
    memoProgram: PublicKey;
    tokenProgram: PublicKey;
    tokenProgram2022: PublicKey;
    instructionSysvarAccount: PublicKey;
    consensusAccount: PublicKey;
    eventAuthority: PublicKey;
}
export declare const layout: any;
export declare function swapUnevenVaults(args: SwapUnevenVaultsArgs, accounts: SwapUnevenVaultsAccounts, programId?: PublicKey): TransactionInstruction;
//# sourceMappingURL=swapUnevenVaults.d.ts.map