import BN from "bn.js";
import * as types from "../types";
export interface PriceFields {
    value: BN;
    exp: BN;
}
export interface PriceJSON {
    value: string;
    exp: string;
}
export declare class Price {
    readonly value: BN;
    readonly exp: BN;
    constructor(fields: PriceFields);
    static layout(property?: string): any;
    static fromDecoded(obj: any): types.Price;
    static toEncodable(fields: PriceFields): {
        value: BN;
        exp: BN;
    };
    toJSON(): PriceJSON;
    static fromJSON(obj: PriceJSON): Price;
    toEncodable(): {
        value: BN;
        exp: BN;
    };
}
//# sourceMappingURL=Price.d.ts.map