import { PublicKey, Connection } from "@solana/web3.js";
import BN from "bn.js";
export interface BinArrayBitmapExtensionFields {
    lbPair: PublicKey;
    /** Packed initialized bin array state for start_bin_index is positive */
    positiveBinArrayBitmap: Array<Array<BN>>;
    /** Packed initialized bin array state for start_bin_index is negative */
    negativeBinArrayBitmap: Array<Array<BN>>;
}
export interface BinArrayBitmapExtensionJSON {
    lbPair: string;
    /** Packed initialized bin array state for start_bin_index is positive */
    positiveBinArrayBitmap: Array<Array<string>>;
    /** Packed initialized bin array state for start_bin_index is negative */
    negativeBinArrayBitmap: Array<Array<string>>;
}
export declare class BinArrayBitmapExtension {
    readonly lbPair: PublicKey;
    /** Packed initialized bin array state for start_bin_index is positive */
    readonly positiveBinArrayBitmap: Array<Array<BN>>;
    /** Packed initialized bin array state for start_bin_index is negative */
    readonly negativeBinArrayBitmap: Array<Array<BN>>;
    static readonly discriminator: Buffer<ArrayBuffer>;
    static readonly layout: any;
    constructor(fields: BinArrayBitmapExtensionFields);
    static fetch(c: Connection, address: PublicKey, programId?: PublicKey): Promise<BinArrayBitmapExtension | null>;
    static fetchMultiple(c: Connection, addresses: PublicKey[], programId?: PublicKey): Promise<Array<BinArrayBitmapExtension | null>>;
    static decode(data: Buffer): BinArrayBitmapExtension;
    toJSON(): BinArrayBitmapExtensionJSON;
    static fromJSON(obj: BinArrayBitmapExtensionJSON): BinArrayBitmapExtension;
}
//# sourceMappingURL=BinArrayBitmapExtension.d.ts.map