"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinArrayBitmapExtension = void 0;
const web3_js_1 = require("@solana/web3.js");
const bn_js_1 = __importDefault(require("bn.js")); // eslint-disable-line @typescript-eslint/no-unused-vars
const borsh = __importStar(require("@coral-xyz/borsh")); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
class BinArrayBitmapExtension {
    lbPair;
    /** Packed initialized bin array state for start_bin_index is positive */
    positiveBinArrayBitmap;
    /** Packed initialized bin array state for start_bin_index is negative */
    negativeBinArrayBitmap;
    static discriminator = Buffer.from([
        80, 111, 124, 113, 55, 237, 18, 5,
    ]);
    static layout = borsh.struct([
        borsh.publicKey("lbPair"),
        borsh.array(borsh.array(borsh.u64(), 8), 12, "positiveBinArrayBitmap"),
        borsh.array(borsh.array(borsh.u64(), 8), 12, "negativeBinArrayBitmap"),
    ]);
    constructor(fields) {
        this.lbPair = fields.lbPair;
        this.positiveBinArrayBitmap = fields.positiveBinArrayBitmap;
        this.negativeBinArrayBitmap = fields.negativeBinArrayBitmap;
    }
    static async fetch(c, address, programId = programId_1.PROGRAM_ID) {
        const info = await c.getAccountInfo(address);
        if (info === null) {
            return null;
        }
        if (!info.owner.equals(programId)) {
            throw new Error("account doesn't belong to this program");
        }
        return this.decode(info.data);
    }
    static async fetchMultiple(c, addresses, programId = programId_1.PROGRAM_ID) {
        const infos = await c.getMultipleAccountsInfo(addresses);
        return infos.map((info) => {
            if (info === null) {
                return null;
            }
            if (!info.owner.equals(programId)) {
                throw new Error("account doesn't belong to this program");
            }
            return this.decode(info.data);
        });
    }
    static decode(data) {
        if (!data.slice(0, 8).equals(BinArrayBitmapExtension.discriminator)) {
            throw new Error("invalid account discriminator");
        }
        const dec = BinArrayBitmapExtension.layout.decode(data.slice(8));
        return new BinArrayBitmapExtension({
            lbPair: dec.lbPair,
            positiveBinArrayBitmap: dec.positiveBinArrayBitmap,
            negativeBinArrayBitmap: dec.negativeBinArrayBitmap,
        });
    }
    toJSON() {
        return {
            lbPair: this.lbPair.toString(),
            positiveBinArrayBitmap: this.positiveBinArrayBitmap.map((item) => item.map((item) => item.toString())),
            negativeBinArrayBitmap: this.negativeBinArrayBitmap.map((item) => item.map((item) => item.toString())),
        };
    }
    static fromJSON(obj) {
        return new BinArrayBitmapExtension({
            lbPair: new web3_js_1.PublicKey(obj.lbPair),
            positiveBinArrayBitmap: obj.positiveBinArrayBitmap.map((item) => item.map((item) => new bn_js_1.default(item))),
            negativeBinArrayBitmap: obj.negativeBinArrayBitmap.map((item) => item.map((item) => new bn_js_1.default(item))),
        });
    }
}
exports.BinArrayBitmapExtension = BinArrayBitmapExtension;
//# sourceMappingURL=BinArrayBitmapExtension.js.map