"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Oracle = void 0;
const bn_js_1 = __importDefault(require("bn.js")); // eslint-disable-line @typescript-eslint/no-unused-vars
const borsh = __importStar(require("@coral-xyz/borsh")); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
class Oracle {
    /** Index of latest observation slot */
    idx;
    /** Size of active sample. Active sample is initialized observation. */
    activeSize;
    /** Number of observations */
    length;
    static discriminator = Buffer.from([
        139, 194, 131, 179, 140, 179, 229, 244,
    ]);
    static layout = borsh.struct([
        borsh.u64("idx"),
        borsh.u64("activeSize"),
        borsh.u64("length"),
    ]);
    constructor(fields) {
        this.idx = fields.idx;
        this.activeSize = fields.activeSize;
        this.length = fields.length;
    }
    static async fetch(c, address, programId = programId_1.PROGRAM_ID) {
        const info = await c.getAccountInfo(address);
        if (info === null) {
            return null;
        }
        if (!info.owner.equals(programId)) {
            throw new Error("account doesn't belong to this program");
        }
        return this.decode(info.data);
    }
    static async fetchMultiple(c, addresses, programId = programId_1.PROGRAM_ID) {
        const infos = await c.getMultipleAccountsInfo(addresses);
        return infos.map((info) => {
            if (info === null) {
                return null;
            }
            if (!info.owner.equals(programId)) {
                throw new Error("account doesn't belong to this program");
            }
            return this.decode(info.data);
        });
    }
    static decode(data) {
        if (!data.slice(0, 8).equals(Oracle.discriminator)) {
            throw new Error("invalid account discriminator");
        }
        const dec = Oracle.layout.decode(data.slice(8));
        return new Oracle({
            idx: dec.idx,
            activeSize: dec.activeSize,
            length: dec.length,
        });
    }
    toJSON() {
        return {
            idx: this.idx.toString(),
            activeSize: this.activeSize.toString(),
            length: this.length.toString(),
        };
    }
    static fromJSON(obj) {
        return new Oracle({
            idx: new bn_js_1.default(obj.idx),
            activeSize: new bn_js_1.default(obj.activeSize),
            length: new bn_js_1.default(obj.length),
        });
    }
}
exports.Oracle = Oracle;
//# sourceMappingURL=Oracle.js.map