import { TransactionInstruction, PublicKey } from "@solana/web3.js";
import * as types from "../types";
export interface AddLiquidityArgs {
    liquidityParameter: types.LiquidityParameterFields;
}
export interface AddLiquidityAccounts {
    position: PublicKey;
    lbPair: PublicKey;
    binArrayBitmapExtension: PublicKey;
    userTokenX: PublicKey;
    userTokenY: PublicKey;
    reserveX: PublicKey;
    reserveY: PublicKey;
    tokenXMint: PublicKey;
    tokenYMint: PublicKey;
    binArrayLower: PublicKey;
    binArrayUpper: PublicKey;
    sender: PublicKey;
    tokenXProgram: PublicKey;
    tokenYProgram: PublicKey;
    eventAuthority: PublicKey;
    program: PublicKey;
}
export declare const layout: any;
export declare function addLiquidity(args: AddLiquidityArgs, accounts: AddLiquidityAccounts, programId?: PublicKey): TransactionInstruction;
//# sourceMappingURL=addLiquidity.d.ts.map