"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.claimFee = claimFee;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function claimFee(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.lbPair, isSigner: false, isWritable: true },
        { pubkey: accounts.position, isSigner: false, isWritable: true },
        { pubkey: accounts.binArrayLower, isSigner: false, isWritable: true },
        { pubkey: accounts.binArrayUpper, isSigner: false, isWritable: true },
        { pubkey: accounts.sender, isSigner: true, isWritable: false },
        { pubkey: accounts.reserveX, isSigner: false, isWritable: true },
        { pubkey: accounts.reserveY, isSigner: false, isWritable: true },
        { pubkey: accounts.userTokenX, isSigner: false, isWritable: true },
        { pubkey: accounts.userTokenY, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenXMint, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenYMint, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.eventAuthority, isSigner: false, isWritable: false },
        { pubkey: accounts.program, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([169, 32, 79, 137, 136, 232, 70, 137]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=claimFee.js.map