"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeBinArrayBitmapExtension = initializeBinArrayBitmapExtension;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function initializeBinArrayBitmapExtension(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.lbPair, isSigner: false, isWritable: false },
        {
            pubkey: accounts.binArrayBitmapExtension,
            isSigner: false,
            isWritable: true,
        },
        { pubkey: accounts.funder, isSigner: true, isWritable: true },
        { pubkey: accounts.systemProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.rent, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([47, 157, 226, 180, 12, 240, 33, 71]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=initializeBinArrayBitmapExtension.js.map