"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.migratePosition = migratePosition;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function migratePosition(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.positionV2, isSigner: true, isWritable: true },
        { pubkey: accounts.positionV1, isSigner: false, isWritable: true },
        { pubkey: accounts.lbPair, isSigner: false, isWritable: false },
        { pubkey: accounts.binArrayLower, isSigner: false, isWritable: true },
        { pubkey: accounts.binArrayUpper, isSigner: false, isWritable: true },
        { pubkey: accounts.owner, isSigner: true, isWritable: true },
        { pubkey: accounts.systemProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.rentReceiver, isSigner: false, isWritable: true },
        { pubkey: accounts.eventAuthority, isSigner: false, isWritable: false },
        { pubkey: accounts.program, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([15, 132, 59, 50, 199, 6, 251, 46]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=migratePosition.js.map