"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeAllLiquidity = removeAllLiquidity;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function removeAllLiquidity(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.position, isSigner: false, isWritable: true },
        { pubkey: accounts.lbPair, isSigner: false, isWritable: true },
        {
            pubkey: accounts.binArrayBitmapExtension,
            isSigner: false,
            isWritable: true,
        },
        { pubkey: accounts.userTokenX, isSigner: false, isWritable: true },
        { pubkey: accounts.userTokenY, isSigner: false, isWritable: true },
        { pubkey: accounts.reserveX, isSigner: false, isWritable: true },
        { pubkey: accounts.reserveY, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenXMint, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenYMint, isSigner: false, isWritable: false },
        { pubkey: accounts.binArrayLower, isSigner: false, isWritable: true },
        { pubkey: accounts.binArrayUpper, isSigner: false, isWritable: true },
        { pubkey: accounts.sender, isSigner: true, isWritable: false },
        { pubkey: accounts.tokenXProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenYProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.eventAuthority, isSigner: false, isWritable: false },
        { pubkey: accounts.program, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([10, 51, 61, 35, 112, 105, 24, 85]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=removeAllLiquidity.js.map