import { PublicKey, Connection } from "@solana/web3.js";
import BN from "bn.js";
export interface AmmConfigFields {
    bump: number;
    index: number;
    owner: PublicKey;
    protocolFeeRate: number;
    tradeFeeRate: number;
    tickSpacing: number;
    fundFeeRate: number;
    paddingU32: number;
    fundOwner: PublicKey;
    padding: Array<BN>;
}
export interface AmmConfigJSON {
    bump: number;
    index: number;
    owner: string;
    protocolFeeRate: number;
    tradeFeeRate: number;
    tickSpacing: number;
    fundFeeRate: number;
    paddingU32: number;
    fundOwner: string;
    padding: Array<string>;
}
export declare class AmmConfig {
    readonly bump: number;
    readonly index: number;
    readonly owner: PublicKey;
    readonly protocolFeeRate: number;
    readonly tradeFeeRate: number;
    readonly tickSpacing: number;
    readonly fundFeeRate: number;
    readonly paddingU32: number;
    readonly fundOwner: PublicKey;
    readonly padding: Array<BN>;
    static readonly discriminator: Buffer<ArrayBuffer>;
    static readonly layout: any;
    constructor(fields: AmmConfigFields);
    static fetch(c: Connection, address: PublicKey, programId?: PublicKey): Promise<AmmConfig | null>;
    static fetchMultiple(c: Connection, addresses: PublicKey[], programId?: PublicKey): Promise<Array<AmmConfig | null>>;
    static decode(data: Buffer): AmmConfig;
    toJSON(): AmmConfigJSON;
    static fromJSON(obj: AmmConfigJSON): AmmConfig;
}
//# sourceMappingURL=AmmConfig.d.ts.map