import { PublicKey, Connection } from "@solana/web3.js";
import BN from "bn.js";
import * as types from "../types";
export interface ObservationStateFields {
    initialized: boolean;
    poolId: PublicKey;
    observations: Array<types.ObservationFields>;
    padding: Array<BN>;
}
export interface ObservationStateJSON {
    initialized: boolean;
    poolId: string;
    observations: Array<types.ObservationJSON>;
    padding: Array<string>;
}
export declare class ObservationState {
    readonly initialized: boolean;
    readonly poolId: PublicKey;
    readonly observations: Array<types.Observation>;
    readonly padding: Array<BN>;
    static readonly discriminator: Buffer<ArrayBuffer>;
    static readonly layout: any;
    constructor(fields: ObservationStateFields);
    static fetch(c: Connection, address: PublicKey, programId?: PublicKey): Promise<ObservationState | null>;
    static fetchMultiple(c: Connection, addresses: PublicKey[], programId?: PublicKey): Promise<Array<ObservationState | null>>;
    static decode(data: Buffer): ObservationState;
    toJSON(): ObservationStateJSON;
    static fromJSON(obj: ObservationStateJSON): ObservationState;
}
//# sourceMappingURL=ObservationState.d.ts.map