"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObservationState = void 0;
const web3_js_1 = require("@solana/web3.js");
const bn_js_1 = __importDefault(require("bn.js")); // eslint-disable-line @typescript-eslint/no-unused-vars
const borsh = __importStar(require("@coral-xyz/borsh")); // eslint-disable-line @typescript-eslint/no-unused-vars
const types = __importStar(require("../types")); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
class ObservationState {
    initialized;
    poolId;
    observations;
    padding;
    static discriminator = Buffer.from([
        122, 174, 197, 53, 129, 9, 165, 132,
    ]);
    static layout = borsh.struct([
        borsh.bool("initialized"),
        borsh.publicKey("poolId"),
        borsh.array(types.Observation.layout(), 1000, "observations"),
        borsh.array(borsh.u128(), 5, "padding"),
    ]);
    constructor(fields) {
        this.initialized = fields.initialized;
        this.poolId = fields.poolId;
        this.observations = fields.observations.map((item) => new types.Observation({ ...item }));
        this.padding = fields.padding;
    }
    static async fetch(c, address, programId = programId_1.PROGRAM_ID) {
        const info = await c.getAccountInfo(address);
        if (info === null) {
            return null;
        }
        if (!info.owner.equals(programId)) {
            throw new Error("account doesn't belong to this program");
        }
        return this.decode(info.data);
    }
    static async fetchMultiple(c, addresses, programId = programId_1.PROGRAM_ID) {
        const infos = await c.getMultipleAccountsInfo(addresses);
        return infos.map((info) => {
            if (info === null) {
                return null;
            }
            if (!info.owner.equals(programId)) {
                throw new Error("account doesn't belong to this program");
            }
            return this.decode(info.data);
        });
    }
    static decode(data) {
        if (!data.slice(0, 8).equals(ObservationState.discriminator)) {
            throw new Error("invalid account discriminator");
        }
        const dec = ObservationState.layout.decode(data.slice(8));
        return new ObservationState({
            initialized: dec.initialized,
            poolId: dec.poolId,
            observations: dec.observations.map((item /* eslint-disable-line @typescript-eslint/no-explicit-any */) => types.Observation.fromDecoded(item)),
            padding: dec.padding,
        });
    }
    toJSON() {
        return {
            initialized: this.initialized,
            poolId: this.poolId.toString(),
            observations: this.observations.map((item) => item.toJSON()),
            padding: this.padding.map((item) => item.toString()),
        };
    }
    static fromJSON(obj) {
        return new ObservationState({
            initialized: obj.initialized,
            poolId: new web3_js_1.PublicKey(obj.poolId),
            observations: obj.observations.map((item) => types.Observation.fromJSON(item)),
            padding: obj.padding.map((item) => new bn_js_1.default(item)),
        });
    }
}
exports.ObservationState = ObservationState;
//# sourceMappingURL=ObservationState.js.map