import { PublicKey, Connection } from "@solana/web3.js";
export interface OperationStateFields {
    bump: number;
    operationOwners: Array<PublicKey>;
    whitelistMints: Array<PublicKey>;
}
export interface OperationStateJSON {
    bump: number;
    operationOwners: Array<string>;
    whitelistMints: Array<string>;
}
export declare class OperationState {
    readonly bump: number;
    readonly operationOwners: Array<PublicKey>;
    readonly whitelistMints: Array<PublicKey>;
    static readonly discriminator: Buffer<ArrayBuffer>;
    static readonly layout: any;
    constructor(fields: OperationStateFields);
    static fetch(c: Connection, address: PublicKey, programId?: PublicKey): Promise<OperationState | null>;
    static fetchMultiple(c: Connection, addresses: PublicKey[], programId?: PublicKey): Promise<Array<OperationState | null>>;
    static decode(data: Buffer): OperationState;
    toJSON(): OperationStateJSON;
    static fromJSON(obj: OperationStateJSON): OperationState;
}
//# sourceMappingURL=OperationState.d.ts.map