"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.OperationState = void 0;
const web3_js_1 = require("@solana/web3.js");
const borsh = __importStar(require("@coral-xyz/borsh")); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
class OperationState {
    bump;
    operationOwners;
    whitelistMints;
    static discriminator = Buffer.from([
        19, 236, 58, 237, 81, 222, 183, 252,
    ]);
    static layout = borsh.struct([
        borsh.u8("bump"),
        borsh.array(borsh.publicKey(), 10, "operationOwners"),
        borsh.array(borsh.publicKey(), 100, "whitelistMints"),
    ]);
    constructor(fields) {
        this.bump = fields.bump;
        this.operationOwners = fields.operationOwners;
        this.whitelistMints = fields.whitelistMints;
    }
    static async fetch(c, address, programId = programId_1.PROGRAM_ID) {
        const info = await c.getAccountInfo(address);
        if (info === null) {
            return null;
        }
        if (!info.owner.equals(programId)) {
            throw new Error("account doesn't belong to this program");
        }
        return this.decode(info.data);
    }
    static async fetchMultiple(c, addresses, programId = programId_1.PROGRAM_ID) {
        const infos = await c.getMultipleAccountsInfo(addresses);
        return infos.map((info) => {
            if (info === null) {
                return null;
            }
            if (!info.owner.equals(programId)) {
                throw new Error("account doesn't belong to this program");
            }
            return this.decode(info.data);
        });
    }
    static decode(data) {
        if (!data.slice(0, 8).equals(OperationState.discriminator)) {
            throw new Error("invalid account discriminator");
        }
        const dec = OperationState.layout.decode(data.slice(8));
        return new OperationState({
            bump: dec.bump,
            operationOwners: dec.operationOwners,
            whitelistMints: dec.whitelistMints,
        });
    }
    toJSON() {
        return {
            bump: this.bump,
            operationOwners: this.operationOwners.map((item) => item.toString()),
            whitelistMints: this.whitelistMints.map((item) => item.toString()),
        };
    }
    static fromJSON(obj) {
        return new OperationState({
            bump: obj.bump,
            operationOwners: obj.operationOwners.map((item) => new web3_js_1.PublicKey(item)),
            whitelistMints: obj.whitelistMints.map((item) => new web3_js_1.PublicKey(item)),
        });
    }
}
exports.OperationState = OperationState;
//# sourceMappingURL=OperationState.js.map