import { PublicKey, Connection } from "@solana/web3.js";
import BN from "bn.js";
export interface ProtocolPositionStateFields {
    bump: number;
    poolId: PublicKey;
    tickLowerIndex: number;
    tickUpperIndex: number;
    liquidity: BN;
    feeGrowthInside0LastX64: BN;
    feeGrowthInside1LastX64: BN;
    tokenFeesOwed0: BN;
    tokenFeesOwed1: BN;
    rewardGrowthInside: Array<BN>;
    padding: Array<BN>;
}
export interface ProtocolPositionStateJSON {
    bump: number;
    poolId: string;
    tickLowerIndex: number;
    tickUpperIndex: number;
    liquidity: string;
    feeGrowthInside0LastX64: string;
    feeGrowthInside1LastX64: string;
    tokenFeesOwed0: string;
    tokenFeesOwed1: string;
    rewardGrowthInside: Array<string>;
    padding: Array<string>;
}
export declare class ProtocolPositionState {
    readonly bump: number;
    readonly poolId: PublicKey;
    readonly tickLowerIndex: number;
    readonly tickUpperIndex: number;
    readonly liquidity: BN;
    readonly feeGrowthInside0LastX64: BN;
    readonly feeGrowthInside1LastX64: BN;
    readonly tokenFeesOwed0: BN;
    readonly tokenFeesOwed1: BN;
    readonly rewardGrowthInside: Array<BN>;
    readonly padding: Array<BN>;
    static readonly discriminator: Buffer<ArrayBuffer>;
    static readonly layout: any;
    constructor(fields: ProtocolPositionStateFields);
    static fetch(c: Connection, address: PublicKey, programId?: PublicKey): Promise<ProtocolPositionState | null>;
    static fetchMultiple(c: Connection, addresses: PublicKey[], programId?: PublicKey): Promise<Array<ProtocolPositionState | null>>;
    static decode(data: Buffer): ProtocolPositionState;
    toJSON(): ProtocolPositionStateJSON;
    static fromJSON(obj: ProtocolPositionStateJSON): ProtocolPositionState;
}
//# sourceMappingURL=ProtocolPositionState.d.ts.map