import { PublicKey, Connection } from "@solana/web3.js";
import BN from "bn.js";
export interface TickArrayBitmapExtensionFields {
    poolId: PublicKey;
    positiveTickArrayBitmap: Array<Array<BN>>;
    negativeTickArrayBitmap: Array<Array<BN>>;
}
export interface TickArrayBitmapExtensionJSON {
    poolId: string;
    positiveTickArrayBitmap: Array<Array<string>>;
    negativeTickArrayBitmap: Array<Array<string>>;
}
export declare class TickArrayBitmapExtension {
    readonly poolId: PublicKey;
    readonly positiveTickArrayBitmap: Array<Array<BN>>;
    readonly negativeTickArrayBitmap: Array<Array<BN>>;
    static readonly discriminator: Buffer<ArrayBuffer>;
    static readonly layout: any;
    constructor(fields: TickArrayBitmapExtensionFields);
    static fetch(c: Connection, address: PublicKey, programId?: PublicKey): Promise<TickArrayBitmapExtension | null>;
    static fetchMultiple(c: Connection, addresses: PublicKey[], programId?: PublicKey): Promise<Array<TickArrayBitmapExtension | null>>;
    static decode(data: Buffer): TickArrayBitmapExtension;
    toJSON(): TickArrayBitmapExtensionJSON;
    static fromJSON(obj: TickArrayBitmapExtensionJSON): TickArrayBitmapExtension;
}
//# sourceMappingURL=TickArrayBitmapExtension.d.ts.map