"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createOperationAccount = createOperationAccount;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function createOperationAccount(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.owner, isSigner: true, isWritable: true },
        { pubkey: accounts.operationState, isSigner: false, isWritable: true },
        { pubkey: accounts.systemProgram, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([63, 87, 148, 33, 109, 35, 8, 104]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=createOperationAccount.js.map