import { TransactionInstruction, PublicKey } from "@solana/web3.js";
import BN from "bn.js";
export interface DecreaseLiquidityArgs {
    liquidity: BN;
    amount0Min: BN;
    amount1Min: BN;
}
export interface DecreaseLiquidityAccounts {
    nftOwner: PublicKey;
    nftAccount: PublicKey;
    personalPosition: PublicKey;
    poolState: PublicKey;
    protocolPosition: PublicKey;
    tokenVault0: PublicKey;
    tokenVault1: PublicKey;
    tickArrayLower: PublicKey;
    tickArrayUpper: PublicKey;
    recipientTokenAccount0: PublicKey;
    recipientTokenAccount1: PublicKey;
    tokenProgram: PublicKey;
}
export declare const layout: any;
export declare function decreaseLiquidity(args: DecreaseLiquidityArgs, accounts: DecreaseLiquidityAccounts, programId?: PublicKey): TransactionInstruction;
//# sourceMappingURL=decreaseLiquidity.d.ts.map