import { TransactionInstruction, PublicKey } from "@solana/web3.js";
import BN from "bn.js";
export interface IncreaseLiquidityV2Args {
    liquidity: BN;
    amount0Max: BN;
    amount1Max: BN;
    baseFlag: boolean | null;
}
export interface IncreaseLiquidityV2Accounts {
    nftOwner: PublicKey;
    nftAccount: PublicKey;
    poolState: PublicKey;
    protocolPosition: PublicKey;
    personalPosition: PublicKey;
    tickArrayLower: PublicKey;
    tickArrayUpper: PublicKey;
    tokenAccount0: PublicKey;
    tokenAccount1: PublicKey;
    tokenVault0: PublicKey;
    tokenVault1: PublicKey;
    tokenProgram: PublicKey;
    tokenProgram2022: PublicKey;
    vault0Mint: PublicKey;
    vault1Mint: PublicKey;
}
export declare const layout: any;
export declare function increaseLiquidityV2(args: IncreaseLiquidityV2Args, accounts: IncreaseLiquidityV2Accounts, programId?: PublicKey): TransactionInstruction;
//# sourceMappingURL=increaseLiquidityV2.d.ts.map