import { TransactionInstruction, PublicKey } from "@solana/web3.js";
import BN from "bn.js";
export interface SwapV2Args {
    amount: BN;
    otherAmountThreshold: BN;
    sqrtPriceLimitX64: BN;
    isBaseInput: boolean;
}
export interface SwapV2Accounts {
    payer: PublicKey;
    ammConfig: PublicKey;
    poolState: PublicKey;
    inputTokenAccount: PublicKey;
    outputTokenAccount: PublicKey;
    inputVault: PublicKey;
    outputVault: PublicKey;
    observationState: PublicKey;
    tokenProgram: PublicKey;
    tokenProgram2022: PublicKey;
    memoProgram: PublicKey;
    inputVaultMint: PublicKey;
    outputVaultMint: PublicKey;
}
export declare const layout: any;
export declare function swapV2(args: SwapV2Args, accounts: SwapV2Accounts, programId?: PublicKey): TransactionInstruction;
//# sourceMappingURL=swapV2.d.ts.map