import { PublicKey } from "@solana/web3.js";
import BN from "bn.js";
import * as types from "../types";
export interface RewardInfoFields {
    rewardState: number;
    openTime: BN;
    endTime: BN;
    lastUpdateTime: BN;
    emissionsPerSecondX64: BN;
    rewardTotalEmissioned: BN;
    rewardClaimed: BN;
    tokenMint: PublicKey;
    tokenVault: PublicKey;
    authority: PublicKey;
    rewardGrowthGlobalX64: BN;
}
export interface RewardInfoJSON {
    rewardState: number;
    openTime: string;
    endTime: string;
    lastUpdateTime: string;
    emissionsPerSecondX64: string;
    rewardTotalEmissioned: string;
    rewardClaimed: string;
    tokenMint: string;
    tokenVault: string;
    authority: string;
    rewardGrowthGlobalX64: string;
}
export declare class RewardInfo {
    readonly rewardState: number;
    readonly openTime: BN;
    readonly endTime: BN;
    readonly lastUpdateTime: BN;
    readonly emissionsPerSecondX64: BN;
    readonly rewardTotalEmissioned: BN;
    readonly rewardClaimed: BN;
    readonly tokenMint: PublicKey;
    readonly tokenVault: PublicKey;
    readonly authority: PublicKey;
    readonly rewardGrowthGlobalX64: BN;
    constructor(fields: RewardInfoFields);
    static layout(property?: string): any;
    static fromDecoded(obj: any): types.RewardInfo;
    static toEncodable(fields: RewardInfoFields): {
        rewardState: number;
        openTime: BN;
        endTime: BN;
        lastUpdateTime: BN;
        emissionsPerSecondX64: BN;
        rewardTotalEmissioned: BN;
        rewardClaimed: BN;
        tokenMint: PublicKey;
        tokenVault: PublicKey;
        authority: PublicKey;
        rewardGrowthGlobalX64: BN;
    };
    toJSON(): RewardInfoJSON;
    static fromJSON(obj: RewardInfoJSON): RewardInfo;
    toEncodable(): {
        rewardState: number;
        openTime: BN;
        endTime: BN;
        lastUpdateTime: BN;
        emissionsPerSecondX64: BN;
        rewardTotalEmissioned: BN;
        rewardClaimed: BN;
        tokenMint: PublicKey;
        tokenVault: PublicKey;
        authority: PublicKey;
        rewardGrowthGlobalX64: BN;
    };
}
//# sourceMappingURL=RewardInfo.d.ts.map