import Decimal from 'decimal.js';
import { PositionRange, RebalanceFieldInfo, RebalanceFieldsDict } from '../utils/types';
import { Dex } from '../utils';
import { RebalanceRaw } from '../kamino-client/types';
export declare const DEFAULT_DRIFT_TICKS_PER_EPOCH: Decimal;
export declare const DEFAULT_TICKS_BELOW_MID: Decimal;
export declare const DEFAULT_TICKS_ABOVE_MID: Decimal;
export declare const DEFAULT_FRONTRUN_MULTIPLIER_BPS: Decimal;
export declare const DEFAULT_STAKING_RATE_SOURCE_A: Decimal;
export declare const DEFAULT_STAKING_RATE_SOURCE_B: Decimal;
export declare const DEFAULT_DIRECTION: Decimal;
export declare const AutodriftRebalanceTypeName = "autodrift";
export declare function getAutodriftRebalanceFieldInfos(dex: Dex, tokenADecimals: number, tokenBDecimals: number, tickSpacing: number, lastMidTick: Decimal, initDriftTicksPerEpoch: Decimal, ticksBelowMid: Decimal, ticksAboveMid: Decimal, frontrunMultiplierBps: Decimal, stakingRateASource: Decimal, stakingRateBSource: Decimal, initialDriftDirection: Decimal, enabled?: boolean): RebalanceFieldInfo[];
export declare function getPositionRangeFromAutodriftParams(dex: Dex, tokenADecimals: number, tokenBDecimals: number, startMidTick: Decimal, ticksBelowMid: Decimal, ticksAboveMid: Decimal, tickSpacing: number): PositionRange;
export declare function getDefaultAutodriftRebalanceFieldInfos(dex: Dex, price: Decimal, tokenADecimals: number, tokenBDecimals: number, tickSpacing: number): RebalanceFieldInfo[];
export declare function readAutodriftRebalanceParamsFromStrategy(rebalanceRaw: RebalanceRaw): RebalanceFieldsDict;
export declare function readRawAutodriftRebalanceStateFromStrategy(rebalanceRaw: RebalanceRaw): RebalanceFieldsDict;
export declare function readAutodriftRebalanceStateFromStrategy(dex: Dex, tokenADecimals: number, tokenBDecimals: number, tickSpacing: number, rebalanceRaw: RebalanceRaw): RebalanceFieldInfo[];
export declare function deserializeAutodriftRebalanceFromOnchainParams(dex: Dex, tokenADecimals: number, tokenBDecimals: number, tickSpacing: number, rebalanceRaw: RebalanceRaw): RebalanceFieldInfo[];
export declare function deserializeAutodriftRebalanceWithStateOverride(dex: Dex, tokenADecimals: number, tokenBDecimals: number, tickSpacing: number, rebalanceRaw: RebalanceRaw): RebalanceFieldInfo[];
//# sourceMappingURL=autodriftRebalance.d.ts.map