import { PoolSimulationResponse } from '../models/PoolSimulationResponseData';
import Decimal from 'decimal.js';
import { PublicKey } from '@solana/web3.js';
export type SimulationParameters = {
    poolAddress: PublicKey;
    depositDate: string;
    endDate: string;
};
export type SimulationManualPoolParameters = SimulationParameters & {
    priceLower: Decimal;
    priceUpper: Decimal;
};
export type SimulationPercentagePoolParameters = SimulationParameters & {
    rangeWidthPriceLower: number;
    rangeWidthPriceUpper: number;
    resetRangeWidthPercUpper?: number;
    resetRangeWidthPercLower?: number;
};
export declare function simulateManualPool(params: SimulationManualPoolParameters): Promise<PoolSimulationResponse>;
export declare function simulatePercentagePool(params: SimulationPercentagePoolParameters): Promise<PoolSimulationResponse>;
//# sourceMappingURL=PoolSimulationService.d.ts.map