"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getReadOnlyWallet = void 0;
const web3_js_1 = require("@solana/web3.js");
/**
 * Get a read-only wallet for Anchor provider
 */
const getReadOnlyWallet = () => {
    const keypair = web3_js_1.Keypair.generate();
    return {
        payer: keypair,
        publicKey: keypair.publicKey,
        signAllTransactions: async (txs) => txs,
        signTransaction: async (txs) => txs,
    };
};
exports.getReadOnlyWallet = getReadOnlyWallet;
//# sourceMappingURL=anchorUtils.js.map