"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.instructionToTransactionInstruction = instructionToTransactionInstruction;
exports.instructionsToTransactionInstructions = instructionsToTransactionInstructions;
exports.transactionInstructionToInstruction = transactionInstructionToInstruction;
exports.transactionInstructionsToInstructions = transactionInstructionsToInstructions;
const web3_js_1 = require("@solana/web3.js");
function instructionToTransactionInstruction(ix) {
    return new web3_js_1.TransactionInstruction({
        keys: ix.accounts.map((acc) => {
            return {
                pubkey: new web3_js_1.PublicKey(acc.pubkey),
                isSigner: acc.isSigner,
                isWritable: acc.isWritable,
            };
        }),
        programId: new web3_js_1.PublicKey(ix.programId),
        data: Buffer.from(ix.data),
    });
}
function instructionsToTransactionInstructions(ixs) {
    return ixs.map((ix) => instructionToTransactionInstruction(ix));
}
function transactionInstructionToInstruction(ix) {
    return {
        accounts: ix.keys.map((acc) => {
            return {
                pubkey: acc.pubkey.toBase58(),
                isSigner: acc.isSigner,
                isWritable: acc.isWritable,
            };
        }),
        programId: ix.programId.toBase58(),
        data: ix.data.toString(),
    };
}
function transactionInstructionsToInstructions(ixs) {
    return ixs.map((ix) => transactionInstructionToInstruction(ix));
}
//# sourceMappingURL=instructions.js.map