import { PublicKey } from '@solana/web3.js';
import Decimal from 'decimal.js';
import { BinArray } from '../meteora_client/accounts';
import { Bin } from '../meteora_client/types';
import { BN } from '@coral-xyz/anchor';
export declare function getPriceOfBinByBinId(binId: number, tickSpacing: number): Decimal;
export declare function getBinIdFromPrice(price: Decimal, tickSpacing: number, min: boolean): number;
export declare function getPriceOfBinByBinIdWithDecimals(binId: number, tickSpacing: number, decimalsA: number, decimalsB: number): Decimal;
export declare function getBinIdFromPriceWithDecimals(price: Decimal, tickSpacing: number, min: boolean, decimalsA: number, decimalsB: number): number;
export declare function getPriceFromQ64Price(price: Decimal, decimalsA: number, decimalsB: number): Decimal;
export declare function getBinArrayLowerUpperBinId(binArrayIndex: number): [number, number];
export declare function getBinFromBinArray(binIndex: number, binArray: BinArray): Bin | null;
export declare function getBinFromBinArrays(binIndex: number, binArrays: BinArray[]): Bin | null;
export declare function binIdToBinArrayIndex(binId: BN): BN;
export declare function deriveBinArray(lbPair: PublicKey, index: BN, programId: PublicKey): [PublicKey, number];
export type MeteoraPosition = {
    publicKey: PublicKey;
    amountX: Decimal;
    amountY: Decimal;
};
//# sourceMappingURL=meteora.d.ts.map