import { PublicKey, TransactionInstruction } from '@solana/web3.js';
import { WhirlpoolStrategy } from '../kamino-client/accounts';
import Decimal from 'decimal.js';
import { DriftDirectionKind, RebalanceAutodriftStepKind, RebalanceTypeKind, StakingRateSourceKind, StrategyConfigOptionKind } from '../kamino-client/types';
import { RebalanceFieldInfo, RebalanceFieldsDict } from './types';
import BN from 'bn.js';
export declare const DolarBasedMintingMethod: Decimal;
export declare const ProportionalMintingMethod: Decimal;
export declare const RebalanceParamOffset: Decimal;
export declare function sleep(ms: number): Promise<unknown>;
export declare const Dex: readonly ["ORCA", "RAYDIUM", "METEORA"];
export type Dex = (typeof Dex)[number];
export declare const ReferencePriceType: readonly [import("./types").PriceReferenceType, import("./types").PriceReferenceType];
export type ReferencePriceType = (typeof ReferencePriceType)[number];
export declare function dexToNumber(dex: Dex): number;
export declare function numberToDex(num: number): Dex;
export declare function numberToReferencePriceType(num: number): ReferencePriceType;
export declare function getDexProgramId(strategyState: WhirlpoolStrategy): PublicKey;
export declare function getStrategyConfigValue(value: Decimal): number[];
export declare function buildStrategyRebalanceParams(params: Array<Decimal>, rebalance_type: RebalanceTypeKind, tokenADecimals?: number, tokenBDecimals?: number): number[];
export declare function doesStrategyHaveResetRange(rebalanceTypeNumber: number): boolean;
export declare function numberToDriftDirection(value: number): DriftDirectionKind;
export declare function numberToStakingRateSource(value: number): StakingRateSourceKind;
export declare function numberToAutodriftStep(value: number): RebalanceAutodriftStepKind;
export declare function numberToRebalanceType(rebalance_type: number): RebalanceTypeKind;
export declare function getUpdateStrategyConfigIx(signer: PublicKey, globalConfig: PublicKey, strategy: PublicKey, mode: StrategyConfigOptionKind, amount: Decimal, newAccount?: PublicKey): Promise<TransactionInstruction>;
export declare function collToLamportsDecimal(amount: Decimal, decimals: number): Decimal;
export declare function lamportsToNumberDecimal(amount: Decimal.Value, decimals: number): Decimal;
export declare function readBigUint128LE(buffer: Buffer, offset: number): bigint;
export declare function readPriceOption(buffer: Buffer, offset: number): [number, Decimal];
export declare function rebalanceFieldsDictToInfo(rebalanceFields: RebalanceFieldsDict): RebalanceFieldInfo[];
export declare function isVaultInitialized(vault: PublicKey, decimals: BN): boolean;
export declare function sqrtPriceToPrice(sqrtPrice: BN, dexNo: number, decimalsA: number, decimalsB: number): Decimal;
export declare function stripTwapZeros(chain: number[]): number[];
export declare function percentageToBPS(pct: number): number;
export declare function keyOrDefault(key: PublicKey, defaultKey: PublicKey): PublicKey;
//# sourceMappingURL=utils.d.ts.map