import { PublicKey, Connection } from "@solana/web3.js";
export interface FeeTierFields {
    whirlpoolsConfig: PublicKey;
    tickSpacing: number;
    defaultFeeRate: number;
}
export interface FeeTierJSON {
    whirlpoolsConfig: string;
    tickSpacing: number;
    defaultFeeRate: number;
}
export declare class FeeTier {
    readonly whirlpoolsConfig: PublicKey;
    readonly tickSpacing: number;
    readonly defaultFeeRate: number;
    static readonly discriminator: Buffer<ArrayBuffer>;
    static readonly layout: any;
    constructor(fields: FeeTierFields);
    static fetch(c: Connection, address: PublicKey, programId?: PublicKey): Promise<FeeTier | null>;
    static fetchMultiple(c: Connection, addresses: PublicKey[], programId?: PublicKey): Promise<Array<FeeTier | null>>;
    static decode(data: Buffer): FeeTier;
    toJSON(): FeeTierJSON;
    static fromJSON(obj: FeeTierJSON): FeeTier;
}
//# sourceMappingURL=FeeTier.d.ts.map