"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.FeeTier = void 0;
const web3_js_1 = require("@solana/web3.js");
const borsh = __importStar(require("@coral-xyz/borsh")); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
class FeeTier {
    whirlpoolsConfig;
    tickSpacing;
    defaultFeeRate;
    static discriminator = Buffer.from([
        56, 75, 159, 76, 142, 68, 190, 105,
    ]);
    static layout = borsh.struct([
        borsh.publicKey("whirlpoolsConfig"),
        borsh.u16("tickSpacing"),
        borsh.u16("defaultFeeRate"),
    ]);
    constructor(fields) {
        this.whirlpoolsConfig = fields.whirlpoolsConfig;
        this.tickSpacing = fields.tickSpacing;
        this.defaultFeeRate = fields.defaultFeeRate;
    }
    static async fetch(c, address, programId = programId_1.PROGRAM_ID) {
        const info = await c.getAccountInfo(address);
        if (info === null) {
            return null;
        }
        if (!info.owner.equals(programId)) {
            throw new Error("account doesn't belong to this program");
        }
        return this.decode(info.data);
    }
    static async fetchMultiple(c, addresses, programId = programId_1.PROGRAM_ID) {
        const infos = await c.getMultipleAccountsInfo(addresses);
        return infos.map((info) => {
            if (info === null) {
                return null;
            }
            if (!info.owner.equals(programId)) {
                throw new Error("account doesn't belong to this program");
            }
            return this.decode(info.data);
        });
    }
    static decode(data) {
        if (!data.slice(0, 8).equals(FeeTier.discriminator)) {
            throw new Error("invalid account discriminator");
        }
        const dec = FeeTier.layout.decode(data.slice(8));
        return new FeeTier({
            whirlpoolsConfig: dec.whirlpoolsConfig,
            tickSpacing: dec.tickSpacing,
            defaultFeeRate: dec.defaultFeeRate,
        });
    }
    toJSON() {
        return {
            whirlpoolsConfig: this.whirlpoolsConfig.toString(),
            tickSpacing: this.tickSpacing,
            defaultFeeRate: this.defaultFeeRate,
        };
    }
    static fromJSON(obj) {
        return new FeeTier({
            whirlpoolsConfig: new web3_js_1.PublicKey(obj.whirlpoolsConfig),
            tickSpacing: obj.tickSpacing,
            defaultFeeRate: obj.defaultFeeRate,
        });
    }
}
exports.FeeTier = FeeTier;
//# sourceMappingURL=FeeTier.js.map