import { PublicKey, Connection } from "@solana/web3.js";
export interface PositionBundleFields {
    positionBundleMint: PublicKey;
    positionBitmap: Array<number>;
}
export interface PositionBundleJSON {
    positionBundleMint: string;
    positionBitmap: Array<number>;
}
export declare class PositionBundle {
    readonly positionBundleMint: PublicKey;
    readonly positionBitmap: Array<number>;
    static readonly discriminator: Buffer<ArrayBuffer>;
    static readonly layout: any;
    constructor(fields: PositionBundleFields);
    static fetch(c: Connection, address: PublicKey, programId?: PublicKey): Promise<PositionBundle | null>;
    static fetchMultiple(c: Connection, addresses: PublicKey[], programId?: PublicKey): Promise<Array<PositionBundle | null>>;
    static decode(data: Buffer): PositionBundle;
    toJSON(): PositionBundleJSON;
    static fromJSON(obj: PositionBundleJSON): PositionBundle;
}
//# sourceMappingURL=PositionBundle.d.ts.map