import { PublicKey, Connection } from "@solana/web3.js";
import * as types from "../types";
export interface TickArrayFields {
    startTickIndex: number;
    ticks: Array<types.TickFields>;
    whirlpool: PublicKey;
}
export interface TickArrayJSON {
    startTickIndex: number;
    ticks: Array<types.TickJSON>;
    whirlpool: string;
}
export declare class TickArray {
    readonly startTickIndex: number;
    readonly ticks: Array<types.Tick>;
    readonly whirlpool: PublicKey;
    static readonly discriminator: Buffer<ArrayBuffer>;
    static readonly layout: any;
    constructor(fields: TickArrayFields);
    static fetch(c: Connection, address: PublicKey, programId?: PublicKey): Promise<TickArray | null>;
    static fetchMultiple(c: Connection, addresses: PublicKey[], programId?: PublicKey): Promise<Array<TickArray | null>>;
    static decode(data: Buffer): TickArray;
    toJSON(): TickArrayJSON;
    static fromJSON(obj: TickArrayJSON): TickArray;
}
//# sourceMappingURL=TickArray.d.ts.map