import { PublicKey, Connection } from "@solana/web3.js";
export interface TokenBadgeFields {
    whirlpoolsConfig: PublicKey;
    tokenMint: PublicKey;
}
export interface TokenBadgeJSON {
    whirlpoolsConfig: string;
    tokenMint: string;
}
export declare class TokenBadge {
    readonly whirlpoolsConfig: PublicKey;
    readonly tokenMint: PublicKey;
    static readonly discriminator: Buffer<ArrayBuffer>;
    static readonly layout: any;
    constructor(fields: TokenBadgeFields);
    static fetch(c: Connection, address: PublicKey, programId?: PublicKey): Promise<TokenBadge | null>;
    static fetchMultiple(c: Connection, addresses: PublicKey[], programId?: PublicKey): Promise<Array<TokenBadge | null>>;
    static decode(data: Buffer): TokenBadge;
    toJSON(): TokenBadgeJSON;
    static fromJSON(obj: TokenBadgeJSON): TokenBadge;
}
//# sourceMappingURL=TokenBadge.d.ts.map