"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.WhirlpoolsConfig = void 0;
const web3_js_1 = require("@solana/web3.js");
const borsh = __importStar(require("@coral-xyz/borsh")); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
class WhirlpoolsConfig {
    feeAuthority;
    collectProtocolFeesAuthority;
    rewardEmissionsSuperAuthority;
    defaultProtocolFeeRate;
    static discriminator = Buffer.from([
        157, 20, 49, 224, 217, 87, 193, 254,
    ]);
    static layout = borsh.struct([
        borsh.publicKey("feeAuthority"),
        borsh.publicKey("collectProtocolFeesAuthority"),
        borsh.publicKey("rewardEmissionsSuperAuthority"),
        borsh.u16("defaultProtocolFeeRate"),
    ]);
    constructor(fields) {
        this.feeAuthority = fields.feeAuthority;
        this.collectProtocolFeesAuthority = fields.collectProtocolFeesAuthority;
        this.rewardEmissionsSuperAuthority = fields.rewardEmissionsSuperAuthority;
        this.defaultProtocolFeeRate = fields.defaultProtocolFeeRate;
    }
    static async fetch(c, address, programId = programId_1.PROGRAM_ID) {
        const info = await c.getAccountInfo(address);
        if (info === null) {
            return null;
        }
        if (!info.owner.equals(programId)) {
            throw new Error("account doesn't belong to this program");
        }
        return this.decode(info.data);
    }
    static async fetchMultiple(c, addresses, programId = programId_1.PROGRAM_ID) {
        const infos = await c.getMultipleAccountsInfo(addresses);
        return infos.map((info) => {
            if (info === null) {
                return null;
            }
            if (!info.owner.equals(programId)) {
                throw new Error("account doesn't belong to this program");
            }
            return this.decode(info.data);
        });
    }
    static decode(data) {
        if (!data.slice(0, 8).equals(WhirlpoolsConfig.discriminator)) {
            throw new Error("invalid account discriminator");
        }
        const dec = WhirlpoolsConfig.layout.decode(data.slice(8));
        return new WhirlpoolsConfig({
            feeAuthority: dec.feeAuthority,
            collectProtocolFeesAuthority: dec.collectProtocolFeesAuthority,
            rewardEmissionsSuperAuthority: dec.rewardEmissionsSuperAuthority,
            defaultProtocolFeeRate: dec.defaultProtocolFeeRate,
        });
    }
    toJSON() {
        return {
            feeAuthority: this.feeAuthority.toString(),
            collectProtocolFeesAuthority: this.collectProtocolFeesAuthority.toString(),
            rewardEmissionsSuperAuthority: this.rewardEmissionsSuperAuthority.toString(),
            defaultProtocolFeeRate: this.defaultProtocolFeeRate,
        };
    }
    static fromJSON(obj) {
        return new WhirlpoolsConfig({
            feeAuthority: new web3_js_1.PublicKey(obj.feeAuthority),
            collectProtocolFeesAuthority: new web3_js_1.PublicKey(obj.collectProtocolFeesAuthority),
            rewardEmissionsSuperAuthority: new web3_js_1.PublicKey(obj.rewardEmissionsSuperAuthority),
            defaultProtocolFeeRate: obj.defaultProtocolFeeRate,
        });
    }
}
exports.WhirlpoolsConfig = WhirlpoolsConfig;
//# sourceMappingURL=WhirlpoolsConfig.js.map