import { PublicKey, Connection } from "@solana/web3.js";
export interface WhirlpoolsConfigExtensionFields {
    whirlpoolsConfig: PublicKey;
    configExtensionAuthority: PublicKey;
    tokenBadgeAuthority: PublicKey;
}
export interface WhirlpoolsConfigExtensionJSON {
    whirlpoolsConfig: string;
    configExtensionAuthority: string;
    tokenBadgeAuthority: string;
}
export declare class WhirlpoolsConfigExtension {
    readonly whirlpoolsConfig: PublicKey;
    readonly configExtensionAuthority: PublicKey;
    readonly tokenBadgeAuthority: PublicKey;
    static readonly discriminator: Buffer<ArrayBuffer>;
    static readonly layout: any;
    constructor(fields: WhirlpoolsConfigExtensionFields);
    static fetch(c: Connection, address: PublicKey, programId?: PublicKey): Promise<WhirlpoolsConfigExtension | null>;
    static fetchMultiple(c: Connection, addresses: PublicKey[], programId?: PublicKey): Promise<Array<WhirlpoolsConfigExtension | null>>;
    static decode(data: Buffer): WhirlpoolsConfigExtension;
    toJSON(): WhirlpoolsConfigExtensionJSON;
    static fromJSON(obj: WhirlpoolsConfigExtensionJSON): WhirlpoolsConfigExtension;
}
//# sourceMappingURL=WhirlpoolsConfigExtension.d.ts.map