"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.WhirlpoolsConfigExtension = void 0;
const web3_js_1 = require("@solana/web3.js");
const borsh = __importStar(require("@coral-xyz/borsh")); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
class WhirlpoolsConfigExtension {
    whirlpoolsConfig;
    configExtensionAuthority;
    tokenBadgeAuthority;
    static discriminator = Buffer.from([
        2, 99, 215, 163, 240, 26, 153, 58,
    ]);
    static layout = borsh.struct([
        borsh.publicKey("whirlpoolsConfig"),
        borsh.publicKey("configExtensionAuthority"),
        borsh.publicKey("tokenBadgeAuthority"),
    ]);
    constructor(fields) {
        this.whirlpoolsConfig = fields.whirlpoolsConfig;
        this.configExtensionAuthority = fields.configExtensionAuthority;
        this.tokenBadgeAuthority = fields.tokenBadgeAuthority;
    }
    static async fetch(c, address, programId = programId_1.PROGRAM_ID) {
        const info = await c.getAccountInfo(address);
        if (info === null) {
            return null;
        }
        if (!info.owner.equals(programId)) {
            throw new Error("account doesn't belong to this program");
        }
        return this.decode(info.data);
    }
    static async fetchMultiple(c, addresses, programId = programId_1.PROGRAM_ID) {
        const infos = await c.getMultipleAccountsInfo(addresses);
        return infos.map((info) => {
            if (info === null) {
                return null;
            }
            if (!info.owner.equals(programId)) {
                throw new Error("account doesn't belong to this program");
            }
            return this.decode(info.data);
        });
    }
    static decode(data) {
        if (!data.slice(0, 8).equals(WhirlpoolsConfigExtension.discriminator)) {
            throw new Error("invalid account discriminator");
        }
        const dec = WhirlpoolsConfigExtension.layout.decode(data.slice(8));
        return new WhirlpoolsConfigExtension({
            whirlpoolsConfig: dec.whirlpoolsConfig,
            configExtensionAuthority: dec.configExtensionAuthority,
            tokenBadgeAuthority: dec.tokenBadgeAuthority,
        });
    }
    toJSON() {
        return {
            whirlpoolsConfig: this.whirlpoolsConfig.toString(),
            configExtensionAuthority: this.configExtensionAuthority.toString(),
            tokenBadgeAuthority: this.tokenBadgeAuthority.toString(),
        };
    }
    static fromJSON(obj) {
        return new WhirlpoolsConfigExtension({
            whirlpoolsConfig: new web3_js_1.PublicKey(obj.whirlpoolsConfig),
            configExtensionAuthority: new web3_js_1.PublicKey(obj.configExtensionAuthority),
            tokenBadgeAuthority: new web3_js_1.PublicKey(obj.tokenBadgeAuthority),
        });
    }
}
exports.WhirlpoolsConfigExtension = WhirlpoolsConfigExtension;
//# sourceMappingURL=WhirlpoolsConfigExtension.js.map