"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.closePosition = closePosition;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function closePosition(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.positionAuthority, isSigner: true, isWritable: false },
        { pubkey: accounts.receiver, isSigner: false, isWritable: true },
        { pubkey: accounts.position, isSigner: false, isWritable: true },
        { pubkey: accounts.positionMint, isSigner: false, isWritable: true },
        {
            pubkey: accounts.positionTokenAccount,
            isSigner: false,
            isWritable: true,
        },
        { pubkey: accounts.tokenProgram, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([123, 134, 81, 0, 49, 68, 98, 98]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=closePosition.js.map