"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.layout = void 0;
exports.decreaseLiquidity = decreaseLiquidity;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const borsh = __importStar(require("@coral-xyz/borsh")); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
exports.layout = borsh.struct([
    borsh.u128("liquidityAmount"),
    borsh.u64("tokenMinA"),
    borsh.u64("tokenMinB"),
]);
function decreaseLiquidity(args, accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.whirlpool, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.positionAuthority, isSigner: true, isWritable: false },
        { pubkey: accounts.position, isSigner: false, isWritable: true },
        {
            pubkey: accounts.positionTokenAccount,
            isSigner: false,
            isWritable: false,
        },
        { pubkey: accounts.tokenOwnerAccountA, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenOwnerAccountB, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenVaultA, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenVaultB, isSigner: false, isWritable: true },
        { pubkey: accounts.tickArrayLower, isSigner: false, isWritable: true },
        { pubkey: accounts.tickArrayUpper, isSigner: false, isWritable: true },
    ];
    const identifier = Buffer.from([160, 38, 208, 111, 104, 91, 44, 1]);
    const buffer = Buffer.alloc(1000);
    const len = exports.layout.encode({
        liquidityAmount: args.liquidityAmount,
        tokenMinA: args.tokenMinA,
        tokenMinB: args.tokenMinB,
    }, buffer);
    const data = Buffer.concat([identifier, buffer]).slice(0, 8 + len);
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=decreaseLiquidity.js.map