import { TransactionInstruction, PublicKey } from "@solana/web3.js";
import BN from "bn.js";
import * as types from "../types";
export interface DecreaseLiquidityV2Args {
    liquidityAmount: BN;
    tokenMinA: BN;
    tokenMinB: BN;
    remainingAccountsInfo: types.RemainingAccountsInfoFields | null;
}
export interface DecreaseLiquidityV2Accounts {
    whirlpool: PublicKey;
    tokenProgramA: PublicKey;
    tokenProgramB: PublicKey;
    memoProgram: PublicKey;
    positionAuthority: PublicKey;
    position: PublicKey;
    positionTokenAccount: PublicKey;
    tokenMintA: PublicKey;
    tokenMintB: PublicKey;
    tokenOwnerAccountA: PublicKey;
    tokenOwnerAccountB: PublicKey;
    tokenVaultA: PublicKey;
    tokenVaultB: PublicKey;
    tickArrayLower: PublicKey;
    tickArrayUpper: PublicKey;
}
export declare const layout: any;
export declare function decreaseLiquidityV2(args: DecreaseLiquidityV2Args, accounts: DecreaseLiquidityV2Accounts, programId?: PublicKey): TransactionInstruction;
//# sourceMappingURL=decreaseLiquidityV2.d.ts.map