"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deletePositionBundle = deletePositionBundle;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function deletePositionBundle(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.positionBundle, isSigner: false, isWritable: true },
        { pubkey: accounts.positionBundleMint, isSigner: false, isWritable: true },
        {
            pubkey: accounts.positionBundleTokenAccount,
            isSigner: false,
            isWritable: true,
        },
        { pubkey: accounts.positionBundleOwner, isSigner: true, isWritable: false },
        { pubkey: accounts.receiver, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenProgram, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([100, 25, 99, 2, 217, 239, 124, 173]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=deletePositionBundle.js.map