"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deleteTokenBadge = deleteTokenBadge;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function deleteTokenBadge(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.whirlpoolsConfig, isSigner: false, isWritable: false },
        {
            pubkey: accounts.whirlpoolsConfigExtension,
            isSigner: false,
            isWritable: false,
        },
        { pubkey: accounts.tokenBadgeAuthority, isSigner: true, isWritable: false },
        { pubkey: accounts.tokenMint, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenBadge, isSigner: false, isWritable: true },
        { pubkey: accounts.receiver, isSigner: false, isWritable: true },
    ];
    const identifier = Buffer.from([53, 146, 68, 8, 18, 117, 17, 185]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=deleteTokenBadge.js.map