"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeConfigExtension = initializeConfigExtension;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function initializeConfigExtension(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.config, isSigner: false, isWritable: false },
        { pubkey: accounts.configExtension, isSigner: false, isWritable: true },
        { pubkey: accounts.funder, isSigner: true, isWritable: true },
        { pubkey: accounts.feeAuthority, isSigner: true, isWritable: false },
        { pubkey: accounts.systemProgram, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([55, 9, 53, 9, 114, 57, 209, 52]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=initializeConfigExtension.js.map