"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializePositionBundle = initializePositionBundle;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function initializePositionBundle(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.positionBundle, isSigner: false, isWritable: true },
        { pubkey: accounts.positionBundleMint, isSigner: true, isWritable: true },
        {
            pubkey: accounts.positionBundleTokenAccount,
            isSigner: false,
            isWritable: true,
        },
        {
            pubkey: accounts.positionBundleOwner,
            isSigner: false,
            isWritable: false,
        },
        { pubkey: accounts.funder, isSigner: true, isWritable: true },
        { pubkey: accounts.tokenProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.systemProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.rent, isSigner: false, isWritable: false },
        {
            pubkey: accounts.associatedTokenProgram,
            isSigner: false,
            isWritable: false,
        },
    ];
    const identifier = Buffer.from([117, 45, 241, 149, 24, 18, 194, 65]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=initializePositionBundle.js.map