"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializePositionBundleWithMetadata = initializePositionBundleWithMetadata;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function initializePositionBundleWithMetadata(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.positionBundle, isSigner: false, isWritable: true },
        { pubkey: accounts.positionBundleMint, isSigner: true, isWritable: true },
        {
            pubkey: accounts.positionBundleMetadata,
            isSigner: false,
            isWritable: true,
        },
        {
            pubkey: accounts.positionBundleTokenAccount,
            isSigner: false,
            isWritable: true,
        },
        {
            pubkey: accounts.positionBundleOwner,
            isSigner: false,
            isWritable: false,
        },
        { pubkey: accounts.funder, isSigner: true, isWritable: true },
        { pubkey: accounts.metadataUpdateAuth, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.systemProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.rent, isSigner: false, isWritable: false },
        {
            pubkey: accounts.associatedTokenProgram,
            isSigner: false,
            isWritable: false,
        },
        { pubkey: accounts.metadataProgram, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([93, 124, 16, 179, 249, 131, 115, 245]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=initializePositionBundleWithMetadata.js.map