"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeTokenBadge = initializeTokenBadge;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function initializeTokenBadge(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.whirlpoolsConfig, isSigner: false, isWritable: false },
        {
            pubkey: accounts.whirlpoolsConfigExtension,
            isSigner: false,
            isWritable: false,
        },
        { pubkey: accounts.tokenBadgeAuthority, isSigner: true, isWritable: false },
        { pubkey: accounts.tokenMint, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenBadge, isSigner: false, isWritable: true },
        { pubkey: accounts.funder, isSigner: true, isWritable: true },
        { pubkey: accounts.systemProgram, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([253, 77, 205, 95, 27, 224, 89, 223]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=initializeTokenBadge.js.map