"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setCollectProtocolFeesAuthority = setCollectProtocolFeesAuthority;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function setCollectProtocolFeesAuthority(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.whirlpoolsConfig, isSigner: false, isWritable: true },
        {
            pubkey: accounts.collectProtocolFeesAuthority,
            isSigner: true,
            isWritable: false,
        },
        {
            pubkey: accounts.newCollectProtocolFeesAuthority,
            isSigner: false,
            isWritable: false,
        },
    ];
    const identifier = Buffer.from([34, 150, 93, 244, 139, 225, 233, 67]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=setCollectProtocolFeesAuthority.js.map