"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setFeeAuthority = setFeeAuthority;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function setFeeAuthority(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.whirlpoolsConfig, isSigner: false, isWritable: true },
        { pubkey: accounts.feeAuthority, isSigner: true, isWritable: false },
        { pubkey: accounts.newFeeAuthority, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([31, 1, 50, 87, 237, 101, 97, 132]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=setFeeAuthority.js.map