"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setRewardEmissionsSuperAuthority = setRewardEmissionsSuperAuthority;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function setRewardEmissionsSuperAuthority(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.whirlpoolsConfig, isSigner: false, isWritable: true },
        {
            pubkey: accounts.rewardEmissionsSuperAuthority,
            isSigner: true,
            isWritable: false,
        },
        {
            pubkey: accounts.newRewardEmissionsSuperAuthority,
            isSigner: false,
            isWritable: false,
        },
    ];
    const identifier = Buffer.from([207, 5, 200, 209, 122, 56, 82, 183]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=setRewardEmissionsSuperAuthority.js.map