"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setTokenBadgeAuthority = setTokenBadgeAuthority;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
function setTokenBadgeAuthority(accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.whirlpoolsConfig, isSigner: false, isWritable: false },
        {
            pubkey: accounts.whirlpoolsConfigExtension,
            isSigner: false,
            isWritable: true,
        },
        {
            pubkey: accounts.configExtensionAuthority,
            isSigner: true,
            isWritable: false,
        },
        {
            pubkey: accounts.newTokenBadgeAuthority,
            isSigner: false,
            isWritable: false,
        },
    ];
    const identifier = Buffer.from([207, 202, 4, 32, 205, 79, 13, 178]);
    const data = identifier;
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=setTokenBadgeAuthority.js.map