import { TransactionInstruction, PublicKey } from "@solana/web3.js";
import BN from "bn.js";
import * as types from "../types";
export interface SwapV2Args {
    amount: BN;
    otherAmountThreshold: BN;
    sqrtPriceLimit: BN;
    amountSpecifiedIsInput: boolean;
    aToB: boolean;
    remainingAccountsInfo: types.RemainingAccountsInfoFields | null;
}
export interface SwapV2Accounts {
    tokenProgramA: PublicKey;
    tokenProgramB: PublicKey;
    memoProgram: PublicKey;
    tokenAuthority: PublicKey;
    whirlpool: PublicKey;
    tokenMintA: PublicKey;
    tokenMintB: PublicKey;
    tokenOwnerAccountA: PublicKey;
    tokenVaultA: PublicKey;
    tokenOwnerAccountB: PublicKey;
    tokenVaultB: PublicKey;
    tickArray0: PublicKey;
    tickArray1: PublicKey;
    tickArray2: PublicKey;
    oracle: PublicKey;
}
export declare const layout: any;
export declare function swapV2(args: SwapV2Args, accounts: SwapV2Accounts, programId?: PublicKey): TransactionInstruction;
//# sourceMappingURL=swapV2.d.ts.map