"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.layout = void 0;
exports.twoHopSwapV2 = twoHopSwapV2;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const borsh = __importStar(require("@coral-xyz/borsh")); // eslint-disable-line @typescript-eslint/no-unused-vars
const types = __importStar(require("../types")); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
exports.layout = borsh.struct([
    borsh.u64("amount"),
    borsh.u64("otherAmountThreshold"),
    borsh.bool("amountSpecifiedIsInput"),
    borsh.bool("aToBOne"),
    borsh.bool("aToBTwo"),
    borsh.u128("sqrtPriceLimitOne"),
    borsh.u128("sqrtPriceLimitTwo"),
    borsh.option(types.RemainingAccountsInfo.layout(), "remainingAccountsInfo"),
]);
function twoHopSwapV2(args, accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.whirlpoolOne, isSigner: false, isWritable: true },
        { pubkey: accounts.whirlpoolTwo, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenMintInput, isSigner: false, isWritable: false },
        {
            pubkey: accounts.tokenMintIntermediate,
            isSigner: false,
            isWritable: false,
        },
        { pubkey: accounts.tokenMintOutput, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenProgramInput, isSigner: false, isWritable: false },
        {
            pubkey: accounts.tokenProgramIntermediate,
            isSigner: false,
            isWritable: false,
        },
        { pubkey: accounts.tokenProgramOutput, isSigner: false, isWritable: false },
        {
            pubkey: accounts.tokenOwnerAccountInput,
            isSigner: false,
            isWritable: true,
        },
        { pubkey: accounts.tokenVaultOneInput, isSigner: false, isWritable: true },
        {
            pubkey: accounts.tokenVaultOneIntermediate,
            isSigner: false,
            isWritable: true,
        },
        {
            pubkey: accounts.tokenVaultTwoIntermediate,
            isSigner: false,
            isWritable: true,
        },
        { pubkey: accounts.tokenVaultTwoOutput, isSigner: false, isWritable: true },
        {
            pubkey: accounts.tokenOwnerAccountOutput,
            isSigner: false,
            isWritable: true,
        },
        { pubkey: accounts.tokenAuthority, isSigner: true, isWritable: false },
        { pubkey: accounts.tickArrayOne0, isSigner: false, isWritable: true },
        { pubkey: accounts.tickArrayOne1, isSigner: false, isWritable: true },
        { pubkey: accounts.tickArrayOne2, isSigner: false, isWritable: true },
        { pubkey: accounts.tickArrayTwo0, isSigner: false, isWritable: true },
        { pubkey: accounts.tickArrayTwo1, isSigner: false, isWritable: true },
        { pubkey: accounts.tickArrayTwo2, isSigner: false, isWritable: true },
        { pubkey: accounts.oracleOne, isSigner: false, isWritable: true },
        { pubkey: accounts.oracleTwo, isSigner: false, isWritable: true },
        { pubkey: accounts.memoProgram, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([186, 143, 209, 29, 254, 2, 194, 117]);
    const buffer = Buffer.alloc(1000);
    const len = exports.layout.encode({
        amount: args.amount,
        otherAmountThreshold: args.otherAmountThreshold,
        amountSpecifiedIsInput: args.amountSpecifiedIsInput,
        aToBOne: args.aToBOne,
        aToBTwo: args.aToBTwo,
        sqrtPriceLimitOne: args.sqrtPriceLimitOne,
        sqrtPriceLimitTwo: args.sqrtPriceLimitTwo,
        remainingAccountsInfo: (args.remainingAccountsInfo &&
            types.RemainingAccountsInfo.toEncodable(args.remainingAccountsInfo)) ||
            null,
    }, buffer);
    const data = Buffer.concat([identifier, buffer]).slice(0, 8 + len);
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=twoHopSwapV2.js.map