import { TransactionInstruction, PublicKey } from "@solana/web3.js";
import BN from "bn.js";
export interface FlashSwapUnevenVaultsEndArgs {
    minRepayAmount: BN;
    amountToLeaveToUser: BN;
    aToB: boolean;
}
export interface FlashSwapUnevenVaultsEndAccounts {
    swapper: PublicKey;
    strategy: PublicKey;
    globalConfig: PublicKey;
    tokenAVault: PublicKey;
    tokenBVault: PublicKey;
    tokenAAta: PublicKey;
    tokenBAta: PublicKey;
    baseVaultAuthority: PublicKey;
    pool: PublicKey;
    position: PublicKey;
    scopePrices: PublicKey;
    tokenInfos: PublicKey;
    tickArrayLower: PublicKey;
    tickArrayUpper: PublicKey;
    tokenAMint: PublicKey;
    tokenBMint: PublicKey;
    tokenATokenProgram: PublicKey;
    tokenBTokenProgram: PublicKey;
    instructionSysvarAccount: PublicKey;
    consensusAccount: PublicKey;
}
export declare const layout: any;
/**
 * End of Flash swap uneven vaults.
 *
 * See [`flash_swap_uneven_vaults_start`] for details.
 *
 * Warning: This instruction is allowed to be used independently from
 * `FlashSwapUnevenVaultsStart` and shall not perform any operation
 * that can be exploited when used alone.
 */
export declare function flashSwapUnevenVaultsEnd(args: FlashSwapUnevenVaultsEndArgs, accounts: FlashSwapUnevenVaultsEndAccounts, programId?: PublicKey): TransactionInstruction;
//# sourceMappingURL=flashSwapUnevenVaultsEnd.d.ts.map