"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.layout = void 0;
exports.flashSwapUnevenVaultsEnd = flashSwapUnevenVaultsEnd;
const web3_js_1 = require("@solana/web3.js"); // eslint-disable-line @typescript-eslint/no-unused-vars
const borsh = __importStar(require("@coral-xyz/borsh")); // eslint-disable-line @typescript-eslint/no-unused-vars
const programId_1 = require("../programId");
exports.layout = borsh.struct([
    borsh.u64("minRepayAmount"),
    borsh.u64("amountToLeaveToUser"),
    borsh.bool("aToB"),
]);
/**
 * End of Flash swap uneven vaults.
 *
 * See [`flash_swap_uneven_vaults_start`] for details.
 *
 * Warning: This instruction is allowed to be used independently from
 * `FlashSwapUnevenVaultsStart` and shall not perform any operation
 * that can be exploited when used alone.
 */
function flashSwapUnevenVaultsEnd(args, accounts, programId = programId_1.PROGRAM_ID) {
    const keys = [
        { pubkey: accounts.swapper, isSigner: true, isWritable: true },
        { pubkey: accounts.strategy, isSigner: false, isWritable: true },
        { pubkey: accounts.globalConfig, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenAVault, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenBVault, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenAAta, isSigner: false, isWritable: true },
        { pubkey: accounts.tokenBAta, isSigner: false, isWritable: true },
        { pubkey: accounts.baseVaultAuthority, isSigner: false, isWritable: true },
        { pubkey: accounts.pool, isSigner: false, isWritable: true },
        { pubkey: accounts.position, isSigner: false, isWritable: true },
        { pubkey: accounts.scopePrices, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenInfos, isSigner: false, isWritable: false },
        { pubkey: accounts.tickArrayLower, isSigner: false, isWritable: false },
        { pubkey: accounts.tickArrayUpper, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenAMint, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenBMint, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenATokenProgram, isSigner: false, isWritable: false },
        { pubkey: accounts.tokenBTokenProgram, isSigner: false, isWritable: false },
        {
            pubkey: accounts.instructionSysvarAccount,
            isSigner: false,
            isWritable: false,
        },
        { pubkey: accounts.consensusAccount, isSigner: false, isWritable: false },
    ];
    const identifier = Buffer.from([226, 2, 190, 101, 202, 132, 156, 20]);
    const buffer = Buffer.alloc(1000);
    const len = exports.layout.encode({
        minRepayAmount: args.minRepayAmount,
        amountToLeaveToUser: args.amountToLeaveToUser,
        aToB: args.aToB,
    }, buffer);
    const data = Buffer.concat([identifier, buffer]).slice(0, 8 + len);
    const ix = new web3_js_1.TransactionInstruction({ keys, programId, data });
    return ix;
}
//# sourceMappingURL=flashSwapUnevenVaultsEnd.js.map